# Conditional settings based on passed in variables
ifdef INTEL
    CC=icc
else
    CC=g++
endif

ifdef DEBUG
    CFLAGS=-c -g -fPIC -fpermissive -std=c++11
else
    # CFLAGS=-c -fPIC -fpermissive -O3 -std=c++11
    CFLAGS=-c -fPIC -fpermissive -std=gnu++14
endif

LIBPATH=../../../libs/x64
INCLUDEPATH=../../../includes

TORCH_PATH=/home/vagrant/ss/sdk/RCM/StrategyStudio/examples/strategies/Group5Strategy/libtorch

INCLUDES=-I/usr/include -I$(INCLUDEPATH) -I$(INCLUDEPATH) -I${TORCH_PATH}/include -I${TORCH_PATH}/include/torch/csrc/api/include
LDFLAGS=$(LIBPATH)/libstrategystudio_analytics.a $(LIBPATH)/libstrategystudio.a $(LIBPATH)/libstrategystudio_transport.a $(LIBPATH)/libstrategystudio_marketmodels.a $(LIBPATH)/libstrategystudio_utilities.a $(LIBPATH)/libstrategystudio_flashprotocol.a
LIBRARY=Group5Strategy.so

SOURCES=Group5Strategy.cpp
HEADERS=Group5Strategy.h
 
OBJECTS=$(SOURCES:.cpp=.o)

all: $(HEADERS) $(LIBRARY)

$(LIBRARY) : $(OBJECTS)
#	$(CC) -shared -Wl,-soname,$(LIBRARY).1 -o $(LIBRARY) $(OBJECTS) $(LDFLAGS)
	$(CC) -shared -Wl,-soname,$(LIBRARY).1,-R${TORCH_PATH}/lib -o $(LIBRARY) $(OBJECTS) $(LDFLAGS) -L${TORCH_PATH}/lib -ltorch -ltorch_cpu -lc10
.cpp.o: $(HEADERS)
	$(CC) $(CFLAGS) $(INCLUDES) $< -o $@

clean:
	rm -rf *.o $(LIBRARY)

copy_strategy: all
	cp $(LIBRARY) /home/vagrant/ss/bt/strategies_dlls/.

launch_backtest: 
	cd /home/vagrant/ss/bt/utilities ; ./StrategyCommandLine cmd start_backtest 2021-11-05 2021-11-05 Test1Group5Strategy 1

run_backtest: all
	cd ~/Downloads/ss_backtesting ; echo $PWD ; ./run_backtest.sh

output_results:
	export CRA_RESULT=`cd ~/Downloads/ss_backtesting ; find ./backtesting-results -name 'BACK*cra' | tail -n 1` ; \
	echo $$CRA_RESULT
	export TEST_VAR="hi" ; \
	echo $$TEST_VAR

